<?php
/*
Plugin Name: d13slideshow
Plugin URI: http://www.d13design.co.uk/d13slideshow/
Description: Add animated slideshows of your featured pages and posts to your templates using &lt;?php d13slideshow(); ?&gt;.
Author: Dave Waller
Version: 1.0.1
Author URI: http://www.d13design.co.uk/
*/ 

// Hook for adding admin menus
add_action('admin_menu', 'd13ss_add_pages');
// Hook for adding options to DB
add_option('d13ss_scriploc', '');
add_option('d13ss_protoloc', '');
add_option('d13ss_width', 480);
add_option('d13ss_height', 360);
add_option('d13ss_fadeTo', '#000000');
add_option('d13ss_transLength', 1);
add_option('d13ss_slideHalt', 4);
add_option('d13ss_linkTarget', '_self');
add_option('d13ss_exceprtLength', 240);
add_option('d13ss_slideNumbers', 1);
add_option('d13ss_slide0', 0);
add_option('d13ss_slide1', 0);
add_option('d13ss_slide2', 0);
add_option('d13ss_slide3', 0);
add_option('d13ss_slide4', 0);
add_option('d13ss_slide5', 0);
add_option('d13ss_slide6', 0);
add_option('d13ss_slide7', 0);
add_option('d13ss_slide8', 0);
add_option('d13ss_slide9', 0);
// action function for above hook
function d13ss_add_pages() {
    // Add a new submenu under Options:
    add_options_page('D13slideshow', 'D13slideshow', 8, 'd13slideshow', 'd13ss_options_page');
}

// d13g_options_page() displays the page content for the Options menu
function d13ss_options_page() { ?>
	<div class="wrap"> 
		<h2>Manage your D13Slideshow <sub style="font-size:0.7em;">- <a href="#help_main">Help</a></sub></h2> 
		<form method="post" action="options.php">
		<?php wp_nonce_field('update-options'); ?>
		<input type="hidden" name="action" value="update" />
		<table width="100%" cellspacing="2" cellpadding="5" class="form-table"> 
		<tr><th width="33%" scope="row"><h3>Setup...</h3></th><td>Leave these blank if your theme handles embedding Script.aculo.us</td></tr>
		<tr> 
		<th width="33%" scope="row">Script.aculo.us location: </th> 
		<td>
		<?php bloginfo('url'); ?>/<input type="text" name="d13ss_scriploc" value="<?php echo get_option('d13ss_scriploc'); ?>" size="40"/>/scriptaculous.js</td> 
		</tr>
		<tr> 
		<th width="33%" scope="row">Prototype location: </th> 
		<td>
		<?php bloginfo('url'); ?>/<input type="text" name="d13ss_protoloc" value="<?php echo get_option('d13ss_protoloc'); ?>" size="40"/>/prototype.js</td> 
		</tr>
		<tr><th width="33%" scope="row"><h3>Settings...</h3></th><td></td></tr>
		<tr> 
		<th width="33%" scope="row">Slideshow width: </th> 
		<td>
		<input type="text" name="d13ss_width" value="<?php echo get_option('d13ss_width'); ?>" size="10"/> px</td> 
		</tr>
		<tr> 
		<th width="33%" scope="row">Slideshow height: </th> 
		<td>
		<input type="text" name="d13ss_height" value="<?php echo get_option('d13ss_height'); ?>" size="10"/> px</td> 
		</tr>
		<tr> 
		<th width="33%" scope="row">Fade to: </th> 
		<td>
		<input type="text" name="d13ss_fadeTo" value="<?php echo get_option('d13ss_fadeTo'); ?>" size="10"/> (hex color starting with #)</td> 
		</tr>
		<tr> 
		<th width="33%" scope="row">Transition length: </th> 
		<td>
		<input type="text" name="d13ss_transLength" value="<?php echo get_option('d13ss_transLength'); ?>" size="10"/> seconds</td> 
		</tr>
		<tr> 
		<th width="33%" scope="row">Slide pause: </th> 
		<td>
		<input type="text" name="d13ss_slideHalt" value="<?php echo get_option('d13ss_slideHalt'); ?>" size="10"/> seconds</td> 
		</tr>
		<tr> 
		<th width="33%" scope="row">Link target: </th> 
		<td>
		<select name="d13ss_linkTarget">
			<option value="_self" <?php if(get_option('d13ss_linkTarget')=='_self'){ echo("selected"); } ?>>_self</option>
			<option value="_blank" <?php if(get_option('d13ss_linkTarget')=='_blank'){ echo("selected"); } ?>>_blank</option>
			<option value="_parent" <?php if(get_option('d13ss_linkTarget')=='_parent'){ echo("selected"); } ?>>_parent</option>
			<option value="_top" <?php if(get_option('d13ss_linkTarget')=='_top'){ echo("selected"); } ?>>_top</option>
		</select>
		</td> 
		</tr>
		<tr> 
		<th width="33%" scope="row">Excerpt length: </th> 
		<td>
		<input type="text" name="d13ss_exceprtLength" value="<?php echo get_option('d13ss_exceprtLength'); ?>" size="5"/> characters</td> 
		</tr>
		<tr> 
		<th width="33%" scope="row">Show slide numbers: </th> 
		<td>
		<select name="d13ss_slideNumbers">
			<option value="1" <?php if(get_option('d13ss_slideNumbers')=='1'){ echo("selected"); } ?>>yes</option>
			<option value="0" <?php if(get_option('d13ss_slideNumbers')=='0'){ echo("selected"); } ?>>no</option>
		</select></td> 
		</tr>
		<tr><th width="33%" scope="row"><h3>Features...</h3></th><td></td></tr>
		<!-- -->
		<?php for($a=1;$a<11;$a++){ ?>
		<tr> 
		<th width="33%" scope="row">Featured story #<?php echo($a); ?>: </th> 
		<td><? $temp = get_option('d13ss_slide'.($a-1)); ?>
		<select name="d13ss_slide<?php echo($a-1); ?>">
			<option value="0" <?php if(get_option('d13ss_slide0')==0){ echo("selected"); } ?>>No story</option>
			<?php
			$pages = get_pages();
			global $page;
			foreach($pages as $page) : ?>
				<option value="<?php echo($page->ID); ?>" <?php if($page->ID==$temp){ echo("selected"); } ?>>Page : <?php echo($page->post_title); ?></option>
			<?php
			endforeach;
			//---
			global $post;
			$myposts = get_posts('numberposts=-1');
			foreach($myposts as $post) :
			setup_postdata($post); ?>
				<option value="<?php echo(the_ID()); ?>" <?php if($post->ID==$temp){ echo("selected"); } ?>><?php the_ID(); ?>: <?php the_title(); ?></option>
			<?php endforeach; ?>
		</select>
		</td> 
		</tr>
		<?php } ?>
		</table>
		<input type="hidden" name="page_options" value="d13ss_scriploc,d13ss_protoloc,d13ss_width,d13ss_height,d13ss_fadeTo,d13ss_transLength,d13ss_slideHalt,d13ss_linkTarget,d13ss_exceprtLength,d13ss_slideNumbers,d13ss_slide0,d13ss_slide1,d13ss_slide2,d13ss_slide3,d13ss_slide4,d13ss_slide5,d13ss_slide6,d13ss_slide7,d13ss_slide8,d13ss_slide9" />
		<p class="submit">
			<input type="submit" name="Submit" value="<?php _e('Update Options &raquo;') ?>" />
		</p>
		</form>
	</div>
	<p>&nbsp;</p>
	<?php require("d13slideshow_help.php"); ?>
	<div class="wrap"> 
		<h2>To do list</h2> 
		<ul>
			<li><s>Create custom effect queue scope</s></li>
			<li><s>Custom field for images</s></li>
			<li>Add failsafe in case no custom field exists</li>
			<li>Funny padding twitch in IE</li>
			<li><s>Nav buttons in IE</s></li>
			<li>Nav button bottom padding in IE</li>
			<li><s>Fix options dropdown to show <strong>all</strong> posts and pages</s></li>
		</ul>
	</div>
<?php }

//Core functions - do not edit below this point...
function d13slideshow(){
	$d13ss_contents = array();
	for($a=0;$a<10;$a++){
		if(get_option('d13ss_slide'.$a)!=0){
			$d13ss_contents[] = get_option('d13ss_slide'.$a);
		}
	}
	
	?>
	<?php if(get_option('d13ss_protoloc')!=""){ ?><script src="<?php bloginfo('url');echo('/'.get_option('d13ss_protoloc')); ?>/prototype.js" type="text/javascript"></script><?php } ?>
	<?php if(get_option('d13ss_scriploc')!=""){ ?><script src="<?php bloginfo('url');echo('/'.get_option('d13ss_scriploc')); ?>/scriptaculous.js" type="text/javascript"></script><?php } ?>
	<style>
	#d13slideshow{
		padding:0px;
		background-color:<?php echo(get_option('d13ss_fadeTo')); ?>;
		width:<?php echo(get_option('d13ss_width')); ?>px;
		height:<?php echo(get_option('d13ss_height')); ?>px;
		margin:0px; }
	#navleft{
		z-index:200;
		position:absolute;
		width:15px;
		height:<?php echo(get_option('d13ss_height')-70); ?>px;
		margin-top:0px;
		margin-left:0px; }
	#navright{
		z-index:201;
		position:absolute;
		width:15px;
		height:<?php echo(get_option('d13ss_height')-70); ?>px;
		margin-top:0px;
		margin-left:<?php echo(get_option('d13ss_width')-15); ?>px; }
	#navleft a,
	#navright a{
		width:15px;
		height:<?php echo(get_option('d13ss_height')-70); ?>px;
		display:block;
		background-color:#000000;
		filter:alpha(opacity=30);-moz-opacity:.3;opacity:.3;
		background-position:center center;
		background-repeat:no-repeat; }
	#navleft a{
		background-image:url(<?php bloginfo('url'); ?>/wp-content/plugins/d13slideshow/img/left.png); }
	#navright a{
		background-image:url(<?php bloginfo('url'); ?>/wp-content/plugins/d13slideshow/img/right.png);  }
	#navleft a:hover{
		filter:alpha(opacity=60);-moz-opacity:.6;opacity:.6; }
	#navright a:hover{
		filter:alpha(opacity=60);-moz-opacity:.6;opacity:.6; }
	div.d13slide{
		padding:0px;
		margin:0px; }
	div.d13slide img{
		padding:0px;
		margin:0px; }
	div.d13fader{
		background-color:#000000;
		color:#FFFFFF;
		font-family:Arial, Helvetica, sans-serif;
		filter:alpha(opacity=60);-moz-opacity:.6;opacity:.6;
		height:70px;
		z-index:1;
		margin:-70px 0px 0px 0px;
		padding:0px; }
	div.d13fader h3{
		font-size:12px;
		font-weight:bold;
		padding:4px;
		margin:0px; }
	div.d13fader p{
		font-size:10px;
		font-weight:normal;
		padding:2px 4px 4px 4px;
		margin:0px; }
	div.d13fader a{
		color:#FFFFFF; }
</style>
<div id="d13slideshow">
<div id="nav" style="display:none;">
<div id="navleft"><a onClick="showPrev()" title="View previous article"></a></div>
<div id="navright"><a onClick="showNext()" title="View next article"></a></div>
</div>
<?php
for($a=0;$a<count($d13ss_contents);$a++){
$d13ss_postdata = get_post(/*$dummyid = */$d13ss_contents[$a]);
$d13ss_promoimage = get_post_custom_values('promoimage', $d13ss_postdata -> ID);
?>
<div id="d<?php echo($a); ?>" class="d13slide" style="display:none;">
<img src="<?php echo($d13ss_promoimage[0]); ?>" alt="<?php echo($d13ss_postdata -> post_title); ?>" width="<?php echo(get_option('d13ss_width')); ?>" height="<?php echo(get_option('d13ss_height')); ?>">
<div class="d13fader">
<p style="font-size:1.2em; font-weight:bold;"><a href="<?php echo($d13ss_postdata -> guid); ?>" title="Read more about <?php echo($d13ss_postdata -> post_title); ?>" target="<?php echo(get_option('d13ss_linkTarget')); ?>">
<?php if(get_option('d13ss_slideNumbers')==1){ ?>
<?php echo(($a+1).'/'.count($d13ss_contents).' '); echo($d13ss_postdata -> post_title); ?>
<?php }else{ ?>
<?php echo($d13ss_postdata -> post_title); ?>
<?php } ?>
</a></p>
<?php
if(strlen($d13ss_postdata -> post_content)>get_option('d13ss_exceprtLength')){ ?>
<p><?php echo(substr($d13ss_postdata -> post_content,0,get_option('d13ss_exceprtLength'))); ?> [ <a href="<?php echo($d13ss_postdata -> guid); ?>" title="Read more about <?php echo($d13ss_postdata -> post_title); ?>" target="<?php echo(get_option('d13ss_linkTarget')); ?>">...</a> ]</p>
<?php }else{ ?>
<p><?php echo($d13ss_postdata -> post_content); ?></p>
<?php } ?>
</div>
</div>
<?php
}
?>
</div>
<script type="text/javascript" language="javascript" charset="utf-8">
// <![CDATA[
currentSlide = 0;
function startTimeline() {
	<?php
	for($a=0;$a<count($d13ss_contents);$a++){
	?>
		new Effect.Appear('d<?php echo($a); ?>', { duration: <?php echo(get_option('d13ss_transLength')); ?>, queue: { position: 'end', scope: 'd13ssscope' } });
		<?php if($a<count($d13ss_contents)-1){ ?>
			new Effect.Fade('d<?php echo($a); ?>', { delay: <?php echo(get_option('d13ss_slideHalt')); ?>, duration: <?php echo(get_option('d13ss_transLength')); ?>, queue: { position: 'end', scope: 'd13ssscope' } });
		<?php } ?>
	<?php
	}
	?>
	new Effect.Fade('d<?php echo($a-1); ?>', { delay: <?php echo(get_option('d13ss_slideHalt')); ?>, duration: <?php echo(get_option('d13ss_transLength')); ?>, queue: { position: 'end', scope: 'd13ssscope' } });
	new Effect.Appear('d0', { duration: <?php echo(get_option('d13ss_transLength')); ?>, queue: { position: 'end', scope: 'd13ssscope' } });
	new Effect.Appear('nav', { delay: 0, duration: 0.1, queue: { position: 'end', scope: 'd13ssscope' }, afterFinish: function() { currentSlide=0; } });
}
function showPrev(){
	new Effect.Fade('d'+currentSlide, { duration: <?php echo(get_option('d13ss_transLength')); ?>, queue: { position: 'end', scope: 'd13ssscope' } });
	currentSlide--;
	if(currentSlide==-1){ currentSlide=<?php echo(count($d13ss_contents)-1); ?>; }
	new Effect.Appear('d'+currentSlide, { duration: <?php echo(get_option('d13ss_transLength')); ?>, queue: { position: 'end', scope: 'd13ssscope' } });
}
function showNext(){
	new Effect.Fade('d'+currentSlide, { duration: <?php echo(get_option('d13ss_transLength')); ?>, queue: { position: 'end', scope: 'd13ssscope' } });
	currentSlide++;
	if(currentSlide==<?php echo(count($d13ss_contents)); ?>){ currentSlide=0; }
	new Effect.Appear('d'+currentSlide, { duration: <?php echo(get_option('d13ss_transLength')); ?>, queue: { position: 'end', scope: 'd13ssscope' } });
}

startTimeline();
// ]]>
</script>
	<?php
}


//add_filter('the_content','d13gallery_replace');
?>